import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../common";
export interface FeesUInterface extends utils.Interface {
    functions: {
        "claimFees(uint256)": FunctionFragment;
        "feePercent()": FunctionFragment;
        "isGuardian(address)": FunctionFragment;
        "isManager(address)": FunctionFragment;
        "owner()": FunctionFragment;
        "renounceOwnership()": FunctionFragment;
        "setFeePercent(uint256)": FunctionFragment;
        "setGuardian(address,bool)": FunctionFragment;
        "setManager(address,bool)": FunctionFragment;
        "transferOwnership(address)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "claimFees" | "feePercent" | "isGuardian" | "isManager" | "owner" | "renounceOwnership" | "setFeePercent" | "setGuardian" | "setManager" | "transferOwnership"): FunctionFragment;
    encodeFunctionData(functionFragment: "claimFees", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "feePercent", values?: undefined): string;
    encodeFunctionData(functionFragment: "isGuardian", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "isManager", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "owner", values?: undefined): string;
    encodeFunctionData(functionFragment: "renounceOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "setFeePercent", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "setGuardian", values: [PromiseOrValue<string>, PromiseOrValue<boolean>]): string;
    encodeFunctionData(functionFragment: "setManager", values: [PromiseOrValue<string>, PromiseOrValue<boolean>]): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [PromiseOrValue<string>]): string;
    decodeFunctionResult(functionFragment: "claimFees", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "feePercent", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isGuardian", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isManager", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "renounceOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setFeePercent", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setGuardian", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setManager", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
    events: {
        "FeePercentUpdated(address,uint256)": EventFragment;
        "FeesClaimed(address,uint256)": EventFragment;
        "GuardianUpdate(address,bool)": EventFragment;
        "ManagerUpdate(address,bool)": EventFragment;
        "OwnershipTransferred(address,address)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "FeePercentUpdated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "FeesClaimed"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "GuardianUpdate"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ManagerUpdate"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
}
export interface FeePercentUpdatedEventObject {
    user: string;
    newFeePercent: BigNumber;
}
export type FeePercentUpdatedEvent = TypedEvent<[
    string,
    BigNumber
], FeePercentUpdatedEventObject>;
export type FeePercentUpdatedEventFilter = TypedEventFilter<FeePercentUpdatedEvent>;
export interface FeesClaimedEventObject {
    user: string;
    amount: BigNumber;
}
export type FeesClaimedEvent = TypedEvent<[
    string,
    BigNumber
], FeesClaimedEventObject>;
export type FeesClaimedEventFilter = TypedEventFilter<FeesClaimedEvent>;
export interface GuardianUpdateEventObject {
    account: string;
    isGuardian: boolean;
}
export type GuardianUpdateEvent = TypedEvent<[
    string,
    boolean
], GuardianUpdateEventObject>;
export type GuardianUpdateEventFilter = TypedEventFilter<GuardianUpdateEvent>;
export interface ManagerUpdateEventObject {
    account: string;
    isManager: boolean;
}
export type ManagerUpdateEvent = TypedEvent<[
    string,
    boolean
], ManagerUpdateEventObject>;
export type ManagerUpdateEventFilter = TypedEventFilter<ManagerUpdateEvent>;
export interface OwnershipTransferredEventObject {
    previousOwner: string;
    newOwner: string;
}
export type OwnershipTransferredEvent = TypedEvent<[
    string,
    string
], OwnershipTransferredEventObject>;
export type OwnershipTransferredEventFilter = TypedEventFilter<OwnershipTransferredEvent>;
export interface FeesU extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: FeesUInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        claimFees(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        feePercent(overrides?: CallOverrides): Promise<[BigNumber]>;
        isGuardian(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        isManager(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        owner(overrides?: CallOverrides): Promise<[string]>;
        renounceOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setFeePercent(newFeePercent: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setGuardian(user: PromiseOrValue<string>, _isGuardian: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setManager(user: PromiseOrValue<string>, _isManager: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
    };
    claimFees(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    feePercent(overrides?: CallOverrides): Promise<BigNumber>;
    isGuardian(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    isManager(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    owner(overrides?: CallOverrides): Promise<string>;
    renounceOwnership(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setFeePercent(newFeePercent: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setGuardian(user: PromiseOrValue<string>, _isGuardian: PromiseOrValue<boolean>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setManager(user: PromiseOrValue<string>, _isManager: PromiseOrValue<boolean>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        claimFees(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        feePercent(overrides?: CallOverrides): Promise<BigNumber>;
        isGuardian(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        isManager(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        owner(overrides?: CallOverrides): Promise<string>;
        renounceOwnership(overrides?: CallOverrides): Promise<void>;
        setFeePercent(newFeePercent: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        setGuardian(user: PromiseOrValue<string>, _isGuardian: PromiseOrValue<boolean>, overrides?: CallOverrides): Promise<void>;
        setManager(user: PromiseOrValue<string>, _isManager: PromiseOrValue<boolean>, overrides?: CallOverrides): Promise<void>;
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
    };
    filters: {
        "FeePercentUpdated(address,uint256)"(user?: PromiseOrValue<string> | null, newFeePercent?: null): FeePercentUpdatedEventFilter;
        FeePercentUpdated(user?: PromiseOrValue<string> | null, newFeePercent?: null): FeePercentUpdatedEventFilter;
        "FeesClaimed(address,uint256)"(user?: PromiseOrValue<string> | null, amount?: null): FeesClaimedEventFilter;
        FeesClaimed(user?: PromiseOrValue<string> | null, amount?: null): FeesClaimedEventFilter;
        "GuardianUpdate(address,bool)"(account?: PromiseOrValue<string> | null, isGuardian?: null): GuardianUpdateEventFilter;
        GuardianUpdate(account?: PromiseOrValue<string> | null, isGuardian?: null): GuardianUpdateEventFilter;
        "ManagerUpdate(address,bool)"(account?: PromiseOrValue<string> | null, isManager?: null): ManagerUpdateEventFilter;
        ManagerUpdate(account?: PromiseOrValue<string> | null, isManager?: null): ManagerUpdateEventFilter;
        "OwnershipTransferred(address,address)"(previousOwner?: PromiseOrValue<string> | null, newOwner?: PromiseOrValue<string> | null): OwnershipTransferredEventFilter;
        OwnershipTransferred(previousOwner?: PromiseOrValue<string> | null, newOwner?: PromiseOrValue<string> | null): OwnershipTransferredEventFilter;
    };
    estimateGas: {
        claimFees(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        feePercent(overrides?: CallOverrides): Promise<BigNumber>;
        isGuardian(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        isManager(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<BigNumber>;
        renounceOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setFeePercent(newFeePercent: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setGuardian(user: PromiseOrValue<string>, _isGuardian: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setManager(user: PromiseOrValue<string>, _isManager: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        claimFees(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        feePercent(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isGuardian(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isManager(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        renounceOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setFeePercent(newFeePercent: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setGuardian(user: PromiseOrValue<string>, _isGuardian: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setManager(user: PromiseOrValue<string>, _isManager: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
    };
}
